TYPO3 Core - Bug #79760

FLUIDTEMPLATE not rendered when Layout name collides with Layout name of FSC
2017-02-11 18:19 - Riccardo De Contardi

Status: Closed Start date: 2017-02-11
Priority: Must have Due date:

Assignee: % Done: 100%

Category: Fluid Styled Content Estimated time: 0.00 hour

Target version:

TYPO3 Version: 8 Complexity:

PHP Version: 71 Is Regression: No

Tags: Sprint Focus: On Location Sprint
Description

Related issues:

Related to TYPO3 Core - Bug #77235: Collision of page template partials havin...
Related to TYPO3 Core - Bug #81415: Section does not exist exception if exten...
Related to TYPO3 Core - Bug #76675: Layout Filename must be unique or fronten...
Related to TYPO3 Core - Bug #81021: Fatal error in fluid_template with switch...
Related to TYPO3 Core - Bug #82338: Wrong Default.html layout file used

Related to TYPO3 Core - Bug #82889: fluid_styled_content major section bug

Closed
Closed
Closed
Closed
Closed
Closed

2016-07-24
2017-06-02
2016-06-17
2017-04-26
2017-09-07
2017-10-31

Associated revisions

Revision 5c048a4c - 2017-11-29 18:13 - Benjamin Franzke
[BUGFIX] Fix recursive FLUIDTEMPLATE cObj's that use layoutRootPaths

FLUIDTEMPLATE variables may contain content elements (e.g. recursive
FLUIDTEMPLATE's) which may instantiate own TemplateViews

(e.g. StandaloneView).

A recursive StandaloneView will statically(!!) cache used TemplatesPaths
in \TYPOGSFluid\Fluid\View\Templates::resolvedFiles.

If StandaloneView is instantiated before, but the fluid layout path is
calculated after inner content objects are being rendering,

the altered statically cached “resolvedFiles™ cache is used

and contains invalid layoutRootPaths.

Short term solution:
Defer the initialization of the StandaloneView (which flushes those
buggy caches) until all variables have been processed.

Change-Id: 1df053b3d0f0835a352790e0ed971344d67844bbc
Releases: master, 8.7

Resolves: #79760

Resolves: #82745

Reviewed-on: https://review.typo3.org/54416

Tested-by: TYPO3com <no-reply@typo3.com>
Reviewed-by: Sebastian Hofer <sebastian.hofer@marit.ag>
Tested-by: Sebastian Hofer <sebastian.hofer@marit.ag>
Reviewed-by: Susanne Moog <susanne.moog@typo3.org>
Tested-by: Susanne Moog <susanne.moog@typo3.org>

Revision dbf5f643 - 2018-01-03 18:54 - Benjamin Franzke
[BUGFIX] Fix recursive FLUIDTEMPLATE cObj's that use layoutRootPaths

FLUIDTEMPLATE variables may contain content elements (e.g. recursive
FLUIDTEMPLATE's) which may instantiate own TemplateViews

(e.g. StandaloneView).

A recursive StandaloneView will statically(!!) cache used TemplatesPaths
in \TYPOSFluid\Fluid\View\Templates::resolvedFiles.
If StandaloneView is instantiated before, but the fluid layout path is
calculated after inner content objects are being rendering,

the altered statically cached “resolvedFiles™ cache is used

and contains invalid layoutRootPaths.

Short term solution:
Defer the initialization of the StandaloneView (which flushes those
buggy caches) until all variables have been processed.

Change-Id: 1df053b3d0f0835a352790e0ed971344d67844bbc
Releases: master, 8.7

Resolves: #79760

Resolves: #82745

Reviewed-on: https://review.typo3.0rg/55252

Tested-by: TYPO3com <no-reply@typo3.com>
Reviewed-by: Susanne Moog <susanne.moog@typo3.org>

Tested-by: Susanne Moog <susanne.moog@typo3.org>

History

#1 - 2017-02-11 18:25 - Riccardo De Contardi

These steps should be sufficient to reproduce on the latest master:
1) Enable and load FSC
2) TS Setup:

page=PAGE
page.1l0 = FLUIDTEMPLATE
page.10 {
templateName = Default
layoutRootPaths {
10 = fileadmin/Layouts
}
partialRootPaths {
10 = fileadmin/Partials
}
templateRootPaths {
10 = fileadmin/Templates
}
}

3) put a Default.html inside /fileadmin/Templates/ with the following content:
<f:layout name="Default" />

<f:section name="content">

<hl>hello world</hl>

</f:section>

4) put a file Default.html inside /fileadmin/Layouts/ with the following content

<f:render section="content" />
5) Result: the page.10 object is ignored and instead you get inside the page:
<div id="cl" class="frame frame- frame-type- frame-layout-1"></div>

where the "c1" has the page ID

If you change the layout name (e.g. "Index.html") and the related <f:layout name="Index" /> everything works again.

#2 - 2017-02-11 21:10 - Riccardo De Contardi
UPDATE

1) to reproduce the issue, you must have a configuration like this one:

page.1l0 = FLUIDTEMPLATE
page.10 {
templateName = Default
layoutRootPaths {
10 = fileadmin/Layouts
}
partialRootPaths {
10 = fileadmin/Partials

}
templateRootPaths {
10 = fileadmin/Templates
}
variables {
maincontent < styles.content.get
}
}

2) If you use a subfolder as repository for the Layouts, e.g.

partialRootPaths {
10 = fileadmin/Layouts/Page

the issue is still present

3) The Default.html of FSC is taken instead of that inside fileadmin/Layouts/Page: if you modify the template:

<f:layout name="Default" />

<f:section name="Main">

<hl>hello world</hl>

</f:section>

you are able to see the content, but you are using the Default.html layout file of FSC: you can even still keep the layout with the wrong section name:

<f:render section="content" />

4) the responsible of the issue is the variable maincontent < styles.content.get
If you remove that line, and use instead:

lib.content = < styles.content.get

in combination with <f:cObject typoscriptObjectPath="lib.content" />, everything works fine

#3 - 2017-02-24 23:30 - Armin Vieweg

I'm using this configuration:
lib.templates.base.file.stdWrap.cObject = CASE
lib.templates.base.file.stdWrap.cObject {

key.field = backend_layout
key.ifEmpty.data = levelfield : -1 , backend_layout_next_level, slide

default = TEXT
default.value = EXT:project/Templates/BackendLayouts/Default.html

pagets___Home = TEXT
pagets__Home.value = EXT:project/Templates/BackendLayouts/Home.html
}

And currently (8.6) | get no output in styles.content.get when fluid_styled_content is included to template. CSS Styled Content works.
Most likely related to this topic?

#4 - 2017-03-01 09:39 - Markus Klein

@Armin: Your are running into https:/forge.typo3.org/issues/80044

#5 - 2017-03-01 10:09 - Andre Koller

| got also no output.

After applying this Patch https://forge.typo3.org/issues/80044

and renaming layout name "Default" it works.

#6 - 2017-03-01 11:42 - Markus Klein

- Status changed from New to Accepted
- Target version set to 8 LTS

- Is Regression changed from No to Yes

- Sprint Focus set to Stabilization Sprint

#7 - 2017-03-01 12:16 - Patrick Broens

Are you sure this is against latest master?
| don't get it that the FLUIDTEMPLATE declared in page.10 is inheriting stuff from FSC.

#8 - 2017-03-01 12:42 - Patrick Broens

I've just tried to reproduce this. New installation on master, with only the TS as mentioned and the template and layout file. FSC installed.

Cannot reproduce this. Body content is as expected.

<hl>hello world</hl>

#9 - 2017-03-01 13:00 - Patrick Broens
Looking at your first TS setup, there is an error
page=PAGE
page.1l0 = FLUIDTEMPLATE
lib.stdcontent {
templateName = Default
layoutRootPaths {
10 = fileadmin/Layouts
}
partialRootPaths {
10 = fileadmin/Partials
}
templateRootPaths {
10 = fileadmin/Templates
}
}

lib.stdcontent should be page.10. But with that error | can't explain why something is rendering at all
#10 - 2017-03-01 13:48 - Markus Klein

- Status changed from Accepted to Needs Feedback

- Assignee deleted (Benni Mack)

- Target version deleted (8 LTS)

- Is Regression changed from Yes to No

#11 - 2017-03-01 23:03 - Riccardo De Contardi

- Status changed from Needs Feedback to Accepted

Yes, you are right, | did a wrong cut and paste. The original lines were:
lib.stdcontent = FLUIDTEMPLATE

ééée.lo < lib.stdcontent

| have updated the issue comment n° 1

#12 - 2017-04-27 12:17 - Wolfgang Wagner

Exact the same problem still in 8.7.1 with this code:

page.1l0 = FLUIDTEMPLATE

page.10 {
layoutRootPath = EXT:myext/Resources/Private/Layouts/
partialRootPath = EXT:myext/Resources/Private/Partials/
file = EXT:myext/Resources/Private/Templates/Default.html

| had a layout file in Resources/Private/Layouts/Default.html

Renaming it to Standard.html (or something else) solved it.

#13 - 2017-04-28 18:48 - taywa gmbh

Same here, took me hours!

| think this is a common problem upgrading from 7 LTS, because examples on the web using <f:layout name="Default" />.
#14 - 2017-05-30 11:49 - Michael Binder

yes, same here.

Renaming the file solved the Problem.

#15 - 2017-06-02 11:13 - Daniel Corn

- Related to Bug #81415: Section does not exist exception if extension layout file is named "Default" added

#16 - 2017-06-02 16:24 - Jan Kiesewetter

| can confirm this problem.

| think this is a caching issue.

Just one Fluid layout from StandaloneView per filename is cached as a php file to typo3temp/var/Cache/Code/fluid_template/layout_Default_xxx.php
This cached layout is used for every FLUIDTEMPLATE / StandaloneView.

#17 - 2017-06-13 10:33 - Florian Gaa

This Issue is also affecting partials in my case. Naming a partial for example ../Partials/Header/Header.html (same as fsc names it) results in no
output of the selfmade partial.

#18 - 2017-06-27 10:53 - Sven Teuber

| can confirm the issue and the "fix" of renaming own Layout files to something other than Default.html on TYPO3 8.7.1 & 8.7.2

#19 - 2017-08-29 10:43 - Tobias Gaertner

Same here TYPO3 8.7.4
Renaming Layout "Default" to "Main" solved it.

PROBLEM is even the ExtensionBuilder creates Layout called "Default"...and | think | followed this "convention" in all projects...and all of us do ;-)

Since it will appear also with other names like naming a partial "Header" will cause the same problem - this should be fixed!!

#20 - 2017-08-29 10:46 - Daniel Corn

Dear TYPO3 Core team! Can you give us a bit of an insight if somebody is working on this issue?

#21 - 2017-09-10 12:47 - Clemens Riccabona

- Related to Bug #76675: Layout Filename must be unique or frontend crashes added

#22 - 2017-09-10 12:48 - Clemens Riccabona

- Related to Bug #81021: Fatal error in fluid_template with switchableControllerActions, one plugin and a shared layout added

#23 - 2017-09-10 12:53 - Clemens Riccabona

It seems, there are a couple of related bug-reports, some with the 'magic words' Template-name Default.html. | also found people having troubles on
german-speaking forums.

e.g. https://webdesign-forum.net/thread-4176-post-18883.html

and https://www.typo3.net/forum/thematik/zeige/kategorie/linux-unix/thema/126195/

#24 - 2017-10-19 10:29 - Gerrit Code Review

- Status changed from Accepted to Under Review

Patch set 6 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/54416

#25 - 2017-11-01 17:44 - Bernhard Eckl
- Related to Bug #82338: Wrong Default.html layout file used added

#26 - 2017-11-04 09:03 - Christian Wellinghorst

Patch works in my situation (https:/forge.typo3.org/issues/82889), which should be the same problem as described here.

#27 - 2017-11-08 18:08 - Mona Muzaffar
- Related to Bug #82889: fluid_styled_content major section bug added

#28 - 2017-11-24 22:50 - Benni Mack
- Sprint Focus changed from Stabilization Sprint to On Location Sprint

#29 - 2017-11-29 18:30 - Benjamin Franzke
- Status changed from Under Review to Resolved

- % Done changed from 0 to 100

Applied in changeset 5c048a4c8017e4d50ab5f2343970a0fd33e4aaed.

#30 - 2018-01-03 17:30 - Gerrit Code Review

- Status changed from Resolved to Under Review

Patch set 1 for branch TYPO3_8-7 of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.0rg/55252

#31 - 2018-01-03 17:32 - Gerrit Code Review

Patch set 2 for branch TYPO3_8-7 of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.0org/55252

#32 - 2018-01-03 19:00 - Benjamin Franzke

- Status changed from Under Review to Resolved

Applied in changeset dbf5f643b5fe9574eb204708b9dc77b404a26f68.

#33 - 2018-01-10 11:01 - Kurt Gusbeth
- PHP Version changed from 7.0 to 7.1

This bug is not fixed yet. | am getting this error with TYPO3 8.7.9:
Fatal error: Cannot declare class layout_default_7c967e45e97a37c67a007855084550c92e894ba4, because the name is already in use in
/xxx/typo3temp/var/Cache/Code/fluid_template/layout_default_7c967e45e97a37c67a007855084550c92e894ba4.php on line 0

Renaming the layout file from default.html to Somethingelse.html solves the problem for me. Now | get this error:
#1225709595: The Fluid template files "/xxx/fileadmin/bsdist/theme/tmpl/backend_layout/Partials/Header.html",
"/xxx/fileadmin/bsdist/theme/tmpl/backend_layout/Partials/Header" could not be loaded.

There were no problems with TYPO3 7 LTS.

#34 - 2018-01-10 11:10 - Jacob Rasmussen

TYPOS 8.7.9 was released in December, whereas this bug was fixed a week ago, so if you want to test whether or not the issue have been fixed, you
need to fetch the TYPOS 8-7 branch from git or wait until the next patch release - which according to the roadmap should be released on the 6th of
february.

https://typo3.org/news/article/typo3-release-improvements-v8-maintenance-release-schedule/

#35 - 2018-01-10 11:20 - Kurt Gusbeth

OK, the patch worked for me.
And renaming the partial header.html to Header.html worked for me too.

#36 - 2018-10-02 11:02 - Benni Mack

- Status changed from Resolved to Closed
